$copyrightHeaderLine1 = "//------------------------------------------------------------"
$copyrightHeaderLine2 = "// Copyright (c) Microsoft Corporation.  All rights reserved."
$copyrightHeaderLine3 = "//------------------------------------------------------------"
$copyrightHeaderLine4 = ""
$headerLine1 = "// This file isn't generated, but this comment is necessary to exclude it from StyleCop analysis."
$headerLine2 = "// <auto-generated/>"
$headerLine3 = ""

Get-ChildItem  -Filter *.cs -File -Recurse  | Foreach-Object {

$currentFileContent = ($_ | Get-Content) 

If (-Not ($currentFileContent | Select-String -Pattern 'Microsoft Corporation.  All rights reserved.'))
{
    Write-Output ""
    Write-Output "Appending header in file " $_.FullName
    Set-Content $_.FullName -value $copyrightHeaderLine1, $copyrightHeaderLine2, $copyrightHeaderLine3, $copyrightHeaderLine4, $headerLine1, $headerLine2, $headerLine3, $currentFileContent
    $currentFileContent = ($_ | Get-Content)
}

If ($currentFileContent | Select-String -Pattern 'public\s*(enum|interface|sealed class|abstract class|static class|class)')
{
    Write-Output ""
    Write-Output "- Modifying, marking public classes as internal in file " $_.FullName

    $listToModify = ($currentFileContent | Select-String -Pattern 'public\s*(enum|interface|sealed class|abstract class|static class|class)') -split '\n'
    
    $listOfChanges = $listToModify -creplace 'public','internal' -split '\n'

    for ($counter=0; $counter -lt $listToModify.Length; $counter++)
    {      
        Write-Output ""
        Write-Output "Class modified from " $listToModify[$counter] " to " $listOfChanges[$counter]
        $currentFileContent = $currentFileContent -creplace [Regex]::Escape($listToModify[$counter]) , $listOfChanges[$counter]
    }

    [IO.File]::WriteAllText($_.FullName, ($currentFileContent -join "`r`n")) 
}
}