﻿// ------------------------------------------------------------
// The code in this repository code was written by Lee Campbell, as a
// derived work from the original Java by Gil Tene of Azul Systems and
// Michael Barker, and released to the public domain, as explained
// at http://creativecommons.org/publicdomain/zero/1.0/
// ------------------------------------------------------------

// This file isn't generated, but this comment is necessary to exclude it from StyleCop analysis.
// <auto-generated/>

namespace HdrHistogram.Utilities
{
    /// <summary>
    /// Extension methods for Arrays.
    /// </summary>
    internal static class ArrayExtensions
    {
        /// <summary>
        /// Checks if the two arrays have the same items in the same order.
        /// </summary>
        /// <typeparam name="T">The type of the items in the arrays.</typeparam>
        /// <param name="source">The source array to check.</param>
        /// <param name="other">The other array to check against.</param>
        /// <returns>Returns <c>true</c> if the arrays are of the same length and each item by index is equal, else <c>false</c>.</returns>
        public static bool IsSequenceEqual<T>(this T[] source, T[] other)
        {
            if (source.Length != other.Length)
                return false;

            for (int i = 0; i < other.Length; i++)
            {
                if (!Equals(source[i], other[i]))
                {
                    return false;
                }
            }
            return true;
        }
    }
}